@echo off
rem #############################################################################
rem # INSTRUCTIONS:
rem # Change the definition of COCOA_LIBRARY to point to the directory where
rem # you have placed the CoCoA library files: that is the directory in which
rem # "lib" resides (but not including "lib"). The path must not be terminated
rem # with a final slash!
rem #
rem # Now change the definition of COCOA_EXECUTABLE to be the path to the
rem # binary executable of CoCoA; this will normally end with ...\wincocoa.exe
rem # Often this is same as COCOA_LIBRARY but with "wincocoa.exe" tacked on the end.
rem #
rem # You can put your preferred starting settings in the file ".cocoarc" in your
rem # home directory.
rem # Make sure, the variable HOME is set correctly!

rem #############################################################################
rem # Make sure these four variables have the correct values for your system.
rem # Below are default values which should work for "standard" installations.

set HOME=c:\My Documents
set COCOA_LIBRARY=C:\Programs\cocoa-4.1
set COCOA_EXECUTABLE=%COCOA_LIBRARY%\cocoa.exe

rem # You should not need to alter anything below this line.
rem #############################################################################
rem #############################################################################

:step1
rem # checking for user init files...

if exist .\.cocoarc goto pos1
if exist .\userinit.coc goto pos2
if exist %HOME%\.cocoarc goto pos3
if exist %HOME%\userinit.coc goto pos4
goto notfound

:pos1
set COCOARC=.\.cocoarc
goto step2

:pos2
set COCOARC=.\userinit.coc
goto step2

:pos3
set COCOARC=%HOME%\.cocoarc
goto step2

:pos4
set COCOARC=%HOME%\userinit.coc
goto step2

:notfound
set COCOARC=
goto step2

rem #############################################################################

:step2
rem # Parse command line arguments...

set QUITATEND=
set COCOABATCHFILES=

:parse
if "%1"=="" goto finished
if "%1"=="-q" goto quitfound
if exist %1 goto appendfile

:fileerror
echo WARNING, ignoring unreadable batch file %1
shift
goto parse

:quitfound
set QUITATEND=Quit;
shift
goto parse

:appendfile
set COCOABATCHFILES=%COCOABATCHFILES%Source("%1");
shift
goto parse

:finished
set COCOABATCHFILES=%COCOABATCHFILES%%QUITATEND%
set QUITATEND=
goto step3

rem #############################################################################

:step3
rem # execute
%COCOA_EXECUTABLE%
