;;==============================================================>
;;    CoCoA-Emacs CUSTOMIZATION: 
;;==============================================================>
;; probably you do not need to change any of these:

;; PATH of the CoCoA directory:
;(setq cocoa-install-dir "/usr/local/cocoa-4.4/")     ;Unix/Linux
;(setq cocoa-install-dir "/Applications/CoCoA-4.4/")  ;Mac
(setq cocoa-install-dir "~/4.4/UI/")                 ;wip

;; PATH for the "cocoa.el" file
(setq load-path (cons (concat cocoa-install-dir "emacs/") load-path))

;; PATH for the "cocoa" start-up script file
;; this usually works:
(setq cocoa-executable (concat cocoa-install-dir "cocoa"))
;; if you moved it into a /bin/ directory, set the complete path:
;(setq cocoa-executable "/usr/local/bin/cocoa")

;; PATH for the file containing the function names (to use dabbrev)
(setq cocoa-wordlist-default-file (concat cocoa-install-dir "wordlist.txt"))

;; PATH of the directory where you usually save your CoCoA files:
(setq cocoa-dir "~/CoCoA/")

;;==============================================================>

;; ------------------------------------------------------------
;; AUTO-LOAD cocoa.el for running CoCoA and cocoa-mode for files
;; with CoCoA extensions
(autoload 'cocoa      "cocoa.el" "CoCoA running mode" 't)
(autoload 'cocoa-mode "cocoa.el" "CoCoA editing mode" 't)

(setq auto-mode-alist  (append auto-mode-alist '(
  ("\\.\\(coc\\|cocoa\\|cocoarc\\|pkg\\|cpkg\\|ts\\)\\'" . cocoa-mode) )))

;; ------------------------------------------------------------
;; AUTO-LOAD wordlist when running CoCoA or using cocoa-mode
(setq cocoa-auto-load-wordlist 't)

;; ------------------------------------------------------------
;; COLOURED SYNTAX (font-lock-mode)
(require 'font-lock) 
(if window-system (global-font-lock-mode t) nil)

;; but if you want font-lock-mode ONLY in cocoa-mode 
;; or if you use XEmacs, choose these instead:
;(if window-system (font-lock-mode 't) nil)
;(add-hook 'cocoa-mode-hook '(lambda () (font-lock-mode 't)))

;; ------------------------------------------------------------
;; AUTOMATIC CAPITALIZATION of CoCoA keywords:
(add-hook 'cocoa-mode-hook '(lambda () (abbrev-mode 't)))

;; ------------------------------------------------------------
;; WORD COMPLETION: 
;; dynamic abbrev expansion (M-/) replace also CASE PATTERN 
(setq dabbrev-case-replace nil)


;; ------------------------------------------------------------
;; ------ OTHER USEFUL SETTINGS ------
;; ------------------------------------------------------------

;; ------------------------------------------------------------
;; PREVENT EXTRANEOUS TABS
(setq indent-tabs-mode 0)

;; ------------------------------------------------------------
;; DISCARD ALL ctrl-m CHARACTERS FROM SHELL OUTPUT
(add-hook 'comint-output-filter-functions 'comint-strip-ctrl-m)

;; ------------------------------------------------------------
;; ALLOWS ACCENTED CHARACTERS
(standard-display-european t)

;; ------------------------------------------------------------
;; MY PREFERRED SET OF COLOURS ;-)
(if window-system 
    (progn
      (set-face-foreground font-lock-comment-face       "red3" )
      (set-face-foreground font-lock-keyword-face       "SteelBlue4" )
      (set-face-foreground font-lock-string-face        "green4" )
      (set-face-foreground font-lock-constant-face      "Orange3" )
      (set-face-foreground font-lock-function-name-face "Blue" )
      (set-face-foreground font-lock-reference-face     "Sienna" )
      (set-face-foreground font-lock-type-face          "Orchid3" )
      )
  nil
  )

;; ------------------------------------------------------------
