/*
 * Written by Volker Augustin <snowbird@bigfoot.de> (02/2001)
 */

#include "pixmaps.h"
#include <qimage.h>

QPixmap createDisabledPixmap(QPixmap& pm)
{
	const QBitmap *mask = pm.mask();
	QImage img = pm.convertToImage();
	if (img.numColors() > 0)
	{
		for (int i = 0; i < img.numColors(); i++)
		{
			int gray = qGray(img.color(i));
			img.setColor(i, gray);
		}
	} else
	{
		for (int x = 0; x < img.width(); x++)
		{
			for (int y = 0; y < img.height(); y++)
			{
				int gray = qGray(img.pixel(x, y));
				int shift = (int) ((255 - gray) / 2);
				gray += shift;
				img.setPixel(x, y, qRgb(gray, gray, gray));
			}
		}
	}
	QPixmap npm;
	npm.convertFromImage(img);
	npm.setMask(*mask);
	return npm;
}

QIconSet createIconSet(const char *xpm[])
{
	QPixmap enabled = QPixmap(xpm);
	QPixmap disabled = createDisabledPixmap(enabled);

	QIconSet set(enabled);
	set.setPixmap(disabled, QIconSet::Automatic, QIconSet::Disabled);
	return set;
}

