#include "win32_registry.h"
#include <iostream.h>

HKEY openRegistryKey(HKEY root, const char* path)
{
	HKEY hkey;
	if (RegOpenKeyEx(root, path, 0, KEY_READ, &hkey) != ERROR_SUCCESS)
	{
		//cout << "Could not open key \"" << path << "\"." << endl;
		return 0;
	}
	
	return hkey;
}

unsigned char * readRegistryStringValue(HKEY hkey, const char* name)
{
	DWORD size, type;
	if (RegQueryValueEx(hkey, name, NULL, &type, NULL, &size) != ERROR_SUCCESS)
	{
		//cout << "Could not determine type and size of value \"" << name << "\"." << endl;
		return 0;
	}

	unsigned char *data = new unsigned char[size];
	if (RegQueryValueEx(hkey, name, NULL, &type, data, &size) != ERROR_SUCCESS)
	{
		//cout << "Could not read value \"" << name << "\"." << endl;
		return 0;
	}
	
	if (type != REG_SZ)
	{
		//cout << "Value is not of type REG_SZ." << endl;
		return 0;
	}
	
	return data;
}

void closeRegistryKey(HKEY hkey)
{
	RegCloseKey(hkey);
}
